{$V-}
{9/18/85}
program Turbo_Dial;

   type
      Str14    = string[14];
      PhoneRec = record
                    Name   : string[20];
                    Number : string[14];
                 end;
      DataRec  = record
                    DialStr : string[10];
                    ComPort : integer;
                    Delay   : real;
                    Baud    : integer;
                    Phone   : array [1..20] of PhoneRec;
                 end;
      DefaultRec = record
                      DialStr : string[10];
                      ComPort : integer;
                      Delay   : real;
                      Baud    : integer;
                   end;
      ScreenRec = record
                     Screen : array [0..3999] of byte;
                     x,y    : byte;
                  end;

   var
      regs  :  record
                  ax,bx,cx,dx,bp,si,di,ds,es,flags : integer;
               end;
      OrigScr  : ScreenRec;
      MonitorAddress  : integer;
      Phone    : array [1..20] of PhoneRec;
      Chosen   : array [1..5] of PhoneRec;
      Defaults : DefaultRec;
      Data     : DataRec;
      DataFile : file of DataRec;
      Machine  : byte absolute $F000:$FFFE;
      page,
      fc1,fc2,
      fc3,fc4,
      fc5,tc1,
      tc2,tc3,
      tc4,tc5,
      tb1,tb2,
      tb3,tb4,
      tb5      : byte;
      option   : char;

{$I \INC\MENU.INC}
{$I \INC\ASYNC.INC}

function MainMenu : char;

   var
      Menu : menu_list_type;

   begin
      menu_init(Menu,3,1,1,1,2);
      menu_add(Menu,'SELECT','Select a Number to Dial',' ');
      menu_add(Menu,'DIAL','Start Sequential Dialing',' ');
      menu_add(Menu,'PAGE','Turn to next page',' ');
      menu_add(Menu,'ADD/CHANGE','Add or Change Dialing Directory Entry',' ');
      menu_add(Menu,'CHANGE','Change Parameters',' ');
      menu_add(Menu,'QUIT','Abort Program',' ');
      menu_finalize(Menu);
      MainMenu := menu_exec(menu,1);
      EraseMenu;
   end;

function SelectMenu(page : byte) : char;

   var
      Menu : menu_list_type;
      i    : byte;
      st   : string[2];

   begin
      menu_init(Menu,2,1,1,1,2);
      for i := 1 to 10 do
         begin
            str(((page * 10) + i),st);
            menu_add(Menu,st,'',chr(((page * 10) + i) + 64));
         end;
      if page = 0 then
         menu_add(Menu,'FORWARD','Advance to Next Page of Numbers','X')
      else
         menu_add(Menu,'BACK','Back up to Previous Page of Numbers','Y');
      menu_add(Menu,'QUIT','Quit Selecting Numbers to Dial','Z');
      menu_finalize(Menu);
      SelectMenu := menu_exec(Menu,1);
      EraseMenu;
   end;

function ParamsMenu : char;

   var
      Menu : menu_list_type;

   begin
      menu_init(Menu,3,1,1,1,2);
      menu_add(Menu,'MODEM','Change Modem Dialing Command',' ');
      menu_add(Menu,'PORT','Change Communications Port',' ');
      menu_add(Menu,'BAUD','Change Baud Rate',' ');
      menu_add(Menu,'DELAY','Change Delay Period',' ');
      menu_add(Menu,'QUIT','Change No Parameters',' ');
      menu_finalize(Menu);
      ParamsMenu := menu_exec(Menu,5);
      EraseMenu;
   end;

function BaudMenu : char;

   var
      Menu : menu_list_type;

   begin
      menu_init(Menu,3,1,1,1,2);
      menu_add(Menu,'300','Set Baud Rate to 300',' ');
      menu_add(Menu,'1200','Set Baud Rate to 1200',' ');
      menu_add(Menu,'2400','Set Baud Rate to 2400',' ');
      menu_finalize(Menu);
      BaudMenu := menu_exec(Menu,2);
      EraseMenu;
   end;

procedure SetAttr;

   begin
      Regs.ax := 15 shl 8;
      intr($10,Regs);
      if (Regs.ax and $FF) <> 7 then
         begin
            textMode(C80);
            MonitorAddress := $B800;
            fc1 := black;
            tc1 := white;
            tb1 := blue;
            fc2 := yellow;
            tc2 := white;
            tb2 := 3;
            fc3 := black;
            tc3 := blue;
            tb3 := brown;
            fc4 := blue;
            tc4 := lightgray;
            tb4 := red;
            fc5 := white;
            tc5 := black;
            tb5 := green;
         end
      else
         begin
            MonitorAddress := $B000;
            fc1 := white;
            tc1 := white;
            tb1 := black;
            fc2 := lightgray;
            tc2 := white;
            tb2 := black;
            fc3 := lightgray;
            tc3 := lightgray;
            tb3 := black;
            fc4 := black;
            tc4 := black;
            tb4 := lightgray;
            fc5 := white;
            tc5 := lightgray;
            tb5 := black;
         end;
   end;

procedure SaveScreen;

   var
      i : integer;

   begin
      with OrigScr do
         begin
            x := whereX;
            y := whereY;
            for i := 0 to 3999 do
               Screen[i] := mem[MonitorAddress:i];
         end;
   end;

procedure RestoreScreen;

   var
      i : integer;

   begin
      with OrigScr do
         begin
            for i := 0 to 3999 do
               mem[MonitorAddress:i] := Screen[i];
            gotoxy(x,y);
         end;
   end;

procedure FullScreen;

   begin
      window(1,1,80,25);
   end;

procedure DrawFrame(x1,y1,x2,y2 : byte);

   var
      i : byte;

   begin
      gotoxy(x1,y1);
      write(chr(214));
      for i := (x1 + 1) to (x2 - 1) do
         begin
            gotoxy(i,y1);
            write(chr(196));
         end;
      write(chr(183));
      for i := (y1 + 1) to (y2 - 1) do
         begin
            gotoxy(x1,i);
            write(chr(186));
            gotoxy(x2,i);
            write(chr(186));
         end;
      gotoxy(x1,y2);
      write(chr(211));
      for i := (x1 + 1) to (x2 - 1) do
         begin
            gotoxy(i,y2);
            write(chr(196));
         end;
      write(chr(189));
   end;

procedure DrawWindow(x1,y1,x2,y2,fc,tc,bc : byte);

   begin
      textcolor(fc);
      textbackground(bc);
      DrawFrame(x1,y1,x2,y2);
      window((x1+1),(y1+1),(x2-1),(y2-1));
      clrscr;
      textcolor(tc);
   end;

procedure WorkWindow;

   begin
      window(3,22,78,24);
      textcolor(tc5);
      textbackground(tb5);
      clrscr;
   end;

procedure VersionWindow;

   begin
      DrawWindow(2,1,51,5,fc1,tc1,tb1);
      gotoxy(15,1);
      write('T U R B O   D I A L');
      gotoxy(20,2);
      write('Ver 1.00a');
      gotoxy(18,3);
      write('by Steve Trace');
      FullScreen;
   end;

procedure NumbersWindow(page : byte);

   var
      i,k  : byte;

   begin
      DrawWindow(3,6,49,19,fc2,tc2,tb2);
      gotoxy(1,1);
      write(' #         NAME                NUMBER');
      for i := 1 to 10 do
         begin
            k := (page * 10) + i;
            gotoxy(1,(i + 2));
            with Phone[k] do
               begin
                  write(k:2,'  ',Name);
                  gotoxy(26,(i + 2));
                  write(Number:14);
               end;
         end;
      FullScreen;
   end;

procedure SequenceWindow(high : byte);

   var
      i : byte;

   begin
      DrawWindow(53,2,79,10,fc3,tc3,tb3);
      gotoxy(6,1);
      write('DIALING SEQUENCE');
      for i := 1 to 5 do
         begin
            if i = high then
               begin
                  textcolor(tb3);
                  textbackground(tc3);
               end
            else
               begin
                  textcolor(tc3);
                  textbackground(tb3);
               end;
            with Chosen[i] do
               begin
                  gotoxy(2,(i+2));
                  write(Name);
               end;
         end;
      FullScreen;
   end;

procedure SpecsWindow;

   begin
      DrawWindow(53,13,79,18,fc4,tc4,tb4);
      gotoxy(1,2);
      with Defaults do
         begin
            write('Dial Command: ');
            textcolor(tb4);
            textbackground(tc4);
            writeln(DialStr);
            textcolor(tc4);
            textbackground(tb4);
            write('Port:         ');
            textcolor(tb4);
            textbackground(tc4);
            writeln(ComPort:2);
            textcolor(tc4);
            textbackground(tb4);
            write('Baud:         ');
            textcolor(tb4);
            textbackground(tc4);
            writeln(Baud:3);
            textcolor(tc4);
            textbackground(tb4);
            write('Delay Period: ');
            textcolor(tb4);
            textbackground(tc4);
            write(Delay:2:0);
            textcolor(tc4);
            textbackground(tb4);
            clreol;
         end;
      FullScreen;
   end;

procedure WorkFrame;

   begin
      DrawWindow(2,21,79,25,fc5,tc5,tb5);
   end;



procedure InitializeWindows;

   begin
      SetAttr;
      SaveScreen;
      textbackground(tb1);
      clrscr;
      VersionWindow;
      NumbersWindow(0);
      SequenceWindow(0);
      SpecsWindow;
      WorkFrame;
   end;

function Time : real;

   begin
      with Regs do
         begin
            ax := $2c00;
            MsDos(Regs);
            Time := (hi(cx) * 360) + (lo(cx) * 60) + hi(dx);
         end;
   end;

procedure SoundAlarm;

   var
      i : integer;

   begin
      noSound;
      repeat
         for i := 430 to 1100 do
            begin
               sound(i);
               if keypressed then
                  begin
                     nosound;
                     exit;
                  end;
            end;
      until keypressed;
      noSound;
   end;

procedure CloseFile;

   var
      k : integer;

   begin
      {$I-} reset(DataFile); {$I+}
      if IOResult <> 0 then
         rewrite(DataFile);
      for k := 1 to 20 do
         Data.Phone[k] := Phone[k];
      Data.Delay := Defaults.Delay;
      Data.ComPort := Defaults.ComPort;
      Data.DialStr := Defaults.DialStr;
      Data.Baud := Defaults.Baud;
      write(DataFile,Data);
      close(DataFile);
      Async_Close;
   end;

procedure Dial(Number : str14; var finished : boolean);

   var
      Sent    : boolean;
      DialStr : string[254];
      NumStr  : string[25];
      Start   : real;
      i       : integer;
      ch      : char;

   begin
      DialStr := '';
      NumStr := Defaults.DialStr + Number + #13;
      finished  := false;
      Start := Time;
      gotoxy(1,1);
      write('Press any key to quit dialing ');
      clreol;
      gotoxy(1,2);
      Async_Send_String(NumStr);
      repeat
         if Async_Buffer_Check(ch) then
            begin
               write(ch);
               DialStr := DialStr + ch;
            end;
         if keypressed then
            begin
               finished := true;
               exit;
            end;
      until ((pos('CONNECT',DialStr) > 0) or (pos('OK',DialStr) > 0)) or ((Time - Start) > Defaults.Delay);
      if pos('CONNECT',DialStr) >  0 then
         begin
            SoundAlarm;
            Async_Send(#13);
            CloseFile;
            RestoreScreen;
            Halt;
         end;
      if pos('OK',DialStr) = 0 then
         begin
            clrscr;
            textcolor(red + blink);
            writeln(' DELAY PERIOD EXPIRED ');
            textcolor(tc5);
            clreol;
            Async_Send(#19);
            repeat ; until not Async_Buffer_Check(ch);
            delay(1200);
            Async_Send_String('+++');
            delay(1200);
            Async_Send(#13);
            Async_Send(#13);
            Async_Send_String('ATZ');
            Async_Send(#13);
            Async_Send(#13);
            delay(2500);
            repeat ; until not Async_Buffer_Check(ch);
         end;
   end;

function DataThere : boolean;

   var
      i : byte;

   begin
      for i := 1 to 5 do
         with Chosen[i] do
            begin
               if length(Number) > 0 then
                  begin
                     DataThere := true;
                     exit;
                  end;
            end;
      DataThere := False;
   end;

procedure DialNumbers;

   var
      i         : integer;
      finished  : boolean;

   begin
      if DataThere then
         repeat
            for i := 1 to 5 do
               with Chosen[i] do
                  if length(Number) > 0 then
                     begin
                        gotoxy(1,2);
                        clreol;
                        FullScreen;
                        SequenceWindow(i);
                        WorkWindow;
                        Dial(Number,finished);
                        if finished then
                           exit;
                     end;
         until finished;
   end;

procedure Initialize;

    var
       Port,
       Speed,
       i      : integer;

    begin
       page := 0;
       assign(DataFile,'TDIAL.REC');
       {$I-} reset(DataFile); {$I+}
       if IOResult <> 0 then
          begin
             rewrite(DataFile);
             fillChar(Data,sizeOf(Data),0);
             with Data do
                begin
                   DialStr := #14 + 'D ';
                   ComPort := 1;
                   Delay   := 20;
                   Baud    := 1200;
                end;
             write(DataFile,Data);
         end
      else
         read(DataFile,Data);
      for i := 1 to 20 do
         Phone[i] := Data.Phone[i];
      with Defaults do
         begin
            DialStr := Data.DialStr;
            ComPort := Data.ComPort;
            Delay   := Data.Delay;
            Baud    := Data.Baud;
         end;
      fillChar(Chosen,SizeOf(Chosen),0);
      Port := Defaults.ComPort;
      Speed := Defaults.Baud;
      Async_init;
      if Async_Open(Port,Speed,'N',8,1) then
         InitializeWindows
      else
         Halt;
   end;

procedure SelectNumbers;

   const
      page : byte = 0;

   var
      i,k  : byte;

   begin
      i := 1;
      fillChar(Chosen,SizeOf(Chosen),0);
      FullScreen;
      SequenceWindow(0);
      WorkWindow;
      repeat
         k := ord(SelectMenu(page mod 2)) - 64;
         if k in [1..20] then
            begin
               Chosen[i] := Phone[k];
               i := i + 1;
               FullScreen;
               SequenceWindow(0);
               WorkWindow;
            end;
         if (k = 24) or (k = 25) then
            begin
               page := page + 1;
               FullScreen;
               NumbersWindow(page mod 2);
               WorkWindow;
            end;
      until (i = 6) or (k = 26);
   end;

procedure AddNumber;

   var
      i,k,
      code       : integer;
      Entry      : string[2];
      TempName   : string[20];
      TempNumber : string[14];

   begin
      gotoxy(1,1);
      TempName := '';
      TempNumber := '';
      write('Add or Change A Phone Entry');
      clreol;
      repeat
         gotoxy(1,2);
         write('Revise Entry Number (1 to 20): ');
         clreol;
         buflen := 2;
         read(Entry);
         val(Entry,i,code);
      until (code = 0) and (i in [1..20]);
      gotoxy(1,2);
      write('Name: ');
      clreol;
      buflen := 20;
      read(TempName);
      if length (TempName) > 0 then
         Phone[i].Name := TempName;
      gotoxy(1,2);
      write('Number: ');
      clreol;
      buflen := 14;
      read(TempNumber);
      if length (TempNumber) > 0 then
         Phone[i].Number := TempNumber;
      clrscr;
      FullScreen;
      NumbersWindow((i - 1) div 10);
      WorkWindow;
   end;

procedure ChangeParams;

   var
      ch,
      cha   : char;
      code  : integer;
      CPort : string[1];
      DStr  : string[2];

   begin
      repeat
         ch := ParamsMenu;
         case ch of
            'M' : begin
                     gotoxy(1,1);
                     write('Enter New Modem Dial Command: ');
                     clreol;
                     Defaults.DialStr := '';
                     repeat
                        read(kbd,cha);
                        if cha <> #13 then
                           begin
                              Defaults.DialStr := Defaults.DialStr + cha;
                              write(cha);
                           end;
                     until cha = #13;
                  end;
            'P' : begin
                     repeat
                        gotoxy(1,1);
                        write('Enter New Port Number (1 or 2): ');
                        clreol;
                        buflen := 1;
                        read(CPort);
                        val(CPort,Defaults.ComPort,code);
                     until (code = 0) and (Defaults.ComPort in [1..2]);
                  end;
            'B' : begin
                     with Defaults do
                        begin
                           ch := BaudMenu;
                           case ch of
                              '3' : Defaults.Baud := 300;
                              '1' : Defaults.Baud := 1200;
                              '2' : Defaults.Baud := 2400;
                           end;
                           Async_Close;
                           if not Async_Open(ComPort,Baud,'N',8,1) then
                              begin
                                 write('SYSTEM FAILURE');
                                 Async_Close;
                                 Halt;
                              end;
                        end;
                  end;
            'D' : begin
                     repeat
                        gotoxy(1,1);
                        write('Enter Redial Delay (10 to 60): ');
                        clreol;
                        buflen := 2;
                        read(DStr);
                        val(DStr,Defaults.Delay,code);
                     until (code = 0) and (Defaults.Delay > 9.9 ) and (Defaults.Delay < 60.1);
                  end;
         end;
         if ch <> 'Q' then
            begin
               FullScreen;
               SpecsWindow;
               WorkWindow;
            end;
      until ch = 'Q';
   end;

begin
   Initialize;
   repeat
      option := MainMenu;
      case option of
         'S' : SelectNumbers;
         'D' : DialNumbers;
         'P' : begin
                  page := page + 1;
                  FullScreen;
                  NumbersWindow(page mod 2);
                  WorkWindow;
               end;
         'A' : AddNumber;
         'C' : ChangeParams;
      end;
   until option = 'Q';
   CloseFile;
   RestoreScreen;
end.